-- Example 03a
-- From Ahammer, Andreas: <http://wi.wu-wien.ac.at/rgf/diplomarbeiten/index.html#bakk_07>
-- a simple print example

-- Retrieve the Desktop object, we need its XComponentLoader interface to load
-- a new document
oDesktop         = UNO.createDesktop()    -- get the UNO Desktop service object
xComponentLoader = oDesktop~XDesktop~XComponentLoader  -- get componentLoader
                                                       -- interface
/* open the swriter - file  */
url = makeUrl("HelloWorld.sxw")  -- get the document from the current folder

props = bsf.createArray(.UNO~propertyValue, 1)  -- create Java array
props[1] = .UNO~propertyValue~new
props[1]~Name  = "Hidden"
props[1]~Value = box("boolean", .true)
xWriterComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, props)

/* set the printer */
xPrintable = xWriterComponent~XPrintable

props[1]~Name  = "Name"
props[1]~Value = "hp deskjet 5600 series" -- the name of your printer
xPrintable~setPrinter(props)

/* set the print-options */
props[1]~Name  = "Pages"
props[1]~Value = "1"
xPrintable~print(props)                   -- print file

::requires UNO.CLS    -- get UNO support

-- A function for getting the file in the current folder

::routine makeUrl    -- operating system independent
  return  ConvertToURL(stream(arg(1), "c", "query exists"))